#------------------------------------------------------------------------------
# Copyright 2006 Adrian Milliner (ps1 at soapyfrog dot com)
# http://ps1.soapyfrog.com
#
# This work is licenced under the Creative Commons 
# Attribution-NonCommercial-ShareAlike 2.5 License. 
# To view a copy of this licence, visit 
# http://creativecommons.org/licenses/by-nc-sa/2.5/ 
# or send a letter to 
# Creative Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.
#------------------------------------------------------------------------------

# $Id: grrr-demo-clock.ps1 82 2007-01-02 15:27:22Z adrian $

# demo1 for grrr.ps1
# run this as a script - do not 'source' it with '.'

$global:___globcheck___=1
$local:___globcheck___=2
if ($global:___globcheck___ -eq 2) {throw "This should not be sourced in global scope"}


# load modules
. .\grrr.ps1



function main {
  $w=80; $h=50
  init-console $w $h
  $pf = create-playfield -x 0 -y 0 -width $w -height $h -bg "black"
  # can't rely on unicode literals and ps1 doesn't support unicode escapes :-(
  $txt = ([string][char]0x2666)*2  
  $secsImg = create-image @($txt,$txt) -bg "black" -fg "red"
  $minsImg = create-image @($txt,$txt) -bg "black" -fg "yellow"
  $hrsImg = create-image @($txt,$txt) -bg "black" -fg "green"

  $pi = [Math]::Pi
  $pd2 = $pi/2
  $twopi = 2*$pi

  $midx = $w/2
  $midy = $h/2

  $secsRadiusX = $midx * 0.9
  $secsRadiusY = $midy * 0.9
  $minsRadiusX = $secsRadiusX*0.9
  $minsRadiusY = $secsRadiusY*0.9
  $hrsRadiusX = $secsRadiusX*0.5
  $hrsRadiusY = $secsRadiusY*0.5

  while ($true) {
    clear-playfield $pf
    $n = get-date

    $hrsAngle = $twopi * (($n.Hour % 12 + ($n.Minute/60)) / 12 ) - $pd2
    $hrsX = $hrsRadiusX * [Math]::Cos($hrsAngle)
    $hrsY = $hrsRadiusY * [Math]::Sin($hrsAngle)
    draw-line $pf $midx $midy ($midx+$hrsX) ($midy+$hrsY) $hrsImg

    $minsAngle = $twopi * ($n.Minute / 60) - $pd2
    $minsX = $minsRadiusX * [Math]::Cos($minsAngle)
    $minsY = $minsRadiusY * [Math]::Sin($minsAngle)
    draw-line $pf $midx $midy ($midx+$minsX) ($midy+$minsY) $minsImg

    $secsAngle = $twopi * ($n.Second / 60) - $pd2
    $secsX = $secsRadiusX * [Math]::Cos($secsAngle)
    $secsY = $secsRadiusY * [Math]::Sin($secsAngle)
    draw-line $pf $midx $midy ($midx+$secsX) ($midy+$secsY) $secsImg

    flush-playfield $pf

    sleep -millis 1000
  }
}

main

